
/**
 * Title:        Diff Word<p>
 * Description:  A diff that is not line based but word based.<p>
 * Copyright:    Copyright (c) Baptiste Lepilleur<p>
 * Company:      Gaia Creation<p>
 * @author Baptiste Lepilleur
 * @version 1.0
 */
package gaiacrtn.diffword;
import java.util.List;
import gaiacrtn.util.ChangeBuilder;
import gaiacrtn.util.Switch;

abstract public class ChangeBuilderMarker implements ChangeBuilder, Switch {

  public void buildChange( List listMarker, int nStatus ) {
    beginChange( listMarker, nStatus );

    int nMarkerCount = listMarker.size();
    for ( int nMarker =0; nMarker < nMarkerCount; ++nMarker )
    {
      ((TextMarker)listMarker.get( nMarker )).apply( this );
    }

    endChange();
  }

  /** Called when beginning a change.
   * Used to set the context for one change.
   * @param listMarker List of markers for this change.
   * @param nStatus Status for this change. See TextMarker.MARKER_NORMAL.
   */
  abstract public void beginChange( List listMarker, int nStatus );

  /** Called when ending a change.
   */
  abstract public void endChange();
}