
/**
 * Title:        Diff Word<p>
 * Description:  A diff that is not line based but word based.<p>
 * Copyright:    Copyright (c) Baptiste Lepilleur<p>
 * Company:      Gaia Creation<p>
 * @author Baptiste Lepilleur
 * @version 1.0
 */
package gaiacrtn.diffword;

public interface TextMarkerFactory {
  /** Retreives a text marker that represents the specified word.
   * @param strWord The created text marker represents this word.
   * @return Text marker for the specified word.
   */
  public TextMarker makeWord( String strWord );

  /** Retreives a text marker that represents the end of a line.
   * @return Text marker that represents the end of a line.
   */
  public TextMarker makeEndLine();
}