
/**
 * Title:        Diff Word<p>
 * Description:  A diff that is not line based but word based.<p>
 * Copyright:    Copyright (c) Baptiste Lepilleur<p>
 * Company:      Gaia Creation<p>
 * @author Baptiste Lepilleur
 * @version 1.0
 */
package gaiacrtn.diffword;
import gaiacrtn.util.Switch;

public class TextMarkerWord implements TextMarker {

  private String _strWord;

  public TextMarkerWord( String strWord ) {
    _strWord = strWord;
  }

  public String word() {
    return _strWord;
  }

  public String toString() {
    return _strWord;
  }

  public int hashCode() {
    return _strWord.hashCode();
  }

  public boolean equals( Object obj ) {
    if ( obj != null  &&  obj instanceof TextMarkerWord )
      return ((TextMarkerWord)obj)._strWord.equals( _strWord );
    return false;
  }

  public void apply( Switch sw ) {
    ((SwitchTextMarker)sw).caseWord( this );
  }
}