
/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */
package gaiacrtn.swing;

import javax.swing.*;
import gaiacrtn.swing.CommandHolder;

public class MenuBuilderCmd implements MenuBuilder {

  private JComponent _menu;
  private CommandHolder _cmdHolder;

  interface MenuComposer {
    /** Add a separator to the menu.
     */
    void addSeparator();

    /** Add the specified action to the menu.
     * @param action Action to add to the menu
     */
    void addAction( Action action );

    /** Add the specified sub-menu to the menu.
     * @param menuSub Sub-menu to add.
     */
    void addSubMenu( JMenu menuSub );
  }


  public void buildMenu(int nMenuType) {
    switch ( nMenuType )
    {
      case MENU_POPUP:
        _menu = new JPopupMenu();
        break;
      case MENU_MENUBAR:
        _menu = new JMenuBar();
        break;
      case MENU_MENU:
        _menu = new JMenu();
        break;
      default:
        _menu = null;
    }
  }

  public void addCommand(String strCmdName) {
    Action action = _cmdHolder.action( strCmdName );
    if ( action != null )
    {
      if ( _menu instanceof JMenu )
        ((JMenu)_menu).add( action );
      else if ( _menu instanceof JPopupMenu )
        ((JPopupMenu)_menu).add( action );
      else {}   // error !!!
    }
  }

  public void addSeparator() {
    if ( _menu instanceof JMenu )
      ((JMenu)_menu).addSeparator();
    else if ( _menu instanceof JPopupMenu )
      ((JPopupMenu)_menu).addSeparator();
    else {}   // error !!!
  }

  public void addSubMenu(JMenu menuSub) {
    if ( _menu instanceof JMenu )
      ((JMenu)_menu).add( menuSub );
    else if ( _menu instanceof JPopupMenu )
      ((JPopupMenu)_menu).add( menuSub );
    else {}   // error !!!
  }
}
