
/**
 * Title:        Diff Word<p>
 * Description:  A diff that is not line based but word based.<p>
 * Copyright:    Copyright (c) Baptiste Lepilleur<p>
 * Company:      Gaia Creation<p>
 * @author Baptiste Lepilleur
 * @version 1.0
 */
package gaiacrtn.util;
import java.util.List;

public interface ChangeBuilder {
  /** Called when beginning building changes.
   * @param listMarker0 First list of markers.
   * @param listMarker1 Second list of markers.
   */
  public void begin( List listMarker0, List listMarker1 );

  /** Called when building a new change block.
   * @param nStatus Status for this change.
   * @see gaiacrtn.util.ChangeStatus
   */
  public void buildChange( List listMarker, int nStatus );

  /** Called when ending building changes.
   */
  public void end();
}