
/**
 * Title:        Diff Word<p>
 * Description:  A diff that is not line based but word based.<p>
 * Copyright:    Copyright (c) Baptiste Lepilleur<p>
 * Company:      Gaia Creation<p>
 * @author Baptiste Lepilleur
 * @version 1.0
 */
package gaiacrtn.util;
import java.util.List;

public class ChangeDirector2To1 extends ChangeDirector {
  public ChangeDirector2To1( ChangeBuilder builderChange ) {
    super( builderChange );
  }

  public void buildChange( List list0, List list1, Diff.change change ) {
      int nOld =0;
      int nOldCount = list1.size();

      _builderChange.begin( list1, list0 );

      while ( change != null )
      {
        int nOldNext = change.line1;
        _builderChange.buildChange( list1.subList( nOld, nOldNext ),
                                    ChangeStatus.NORMAL );
        nOld = nOldNext;

        if ( change.inserted > 0 )
        {
          _builderChange.buildChange(
              list1.subList( change.line1, change.line1 + change.inserted ),
              ChangeStatus.DELETED );
          nOld = change.line1 + change.inserted;
        }

        if ( change.deleted > 0 )
        {
          _builderChange.buildChange(
              list0.subList( change.line0, change.line0 + change.deleted ),
              ChangeStatus.INSERTED );
        }

        change = change.link;
      }

      if ( nOld <= nOldCount )
      {
        _builderChange.buildChange( list1.subList( nOld, nOldCount ),
                                    ChangeStatus.NORMAL  );
      }

      _builderChange.end();
  }
}